## visad
Class RealTupleType

    java.lang.Object
      visad.MathType
          visad.TupleType
              visad.RealTupleType

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  DisplayTupleType, RealVectorType

public class RealTupleType
extends TupleType

RealTupleType is the VisAD data type for tuples in R^n, for n>0.

See Also:
  Serialized Form

Field Summary
`static RealTupleType` `Generic2D` System intrinsic for (RealType.Generic, RealType.Generic)
`static RealTupleType` `Generic3D` System intrinsic for (RealType.Generic, RealType.Generic, RealType.Generic)
`static RealTupleType` `LatitudeLongitudeAltitude` System intrinsic for (RealType.Latitude, RealType.Longitude, RealType.Altitude)
`static RealTupleType` `LatitudeLongitudeTuple` System intrinsic for (RealType.Latitude, RealType.Longitude)
`static RealTupleType` `SpatialCartesian2DTuple` System intrinsic RealTupleType for (RealType.XAxis, RealType.YAxis)
`static RealTupleType` `SpatialCartesian3DTuple` System intrinsic for (RealType.XAxis, RealType.YAxis, RealType.ZAxis)
`static RealTupleType` `SpatialEarth2DTuple` System intrinsic for (RealType.Longitude, RealType.Latitude)
`static RealTupleType` `SpatialEarth3DTuple` System intrinsic for (RealType.Longitude, RealType.Latitude, RealType.Altitude)
`static RealTupleType` `Time1DTuple` System intrinsic for (RealType.Time)

Fields inherited from class visad.MathType
`SystemIntrinsic`

Constructor Summary
`` `RealTupleType(RealType a)` construct a RealTupleType with one component
`` `RealTupleType(RealType[] types)` array of component types; default CoordinateSystem and Set are null
`(package private)` `RealTupleType(RealType[] types, boolean b)` trusted constructor for initializers
`(package private)` `RealTupleType(RealType[] types, CoordinateSystem coord_sys, boolean b)` trusted constructor for initializers
`` `RealTupleType(RealType[] types, CoordinateSystem coord_sys, Set set)` array of component types; default CoordinateSystem for values of this type (including Function domains) and may be null; default Set used when this type is a FunctionType domain and may be null
`` `RealTupleType(RealType a, CoordinateSystem coord_sys, Set set)` construct a RealTupleType with one component
`` `RealTupleType(RealType a, RealType b)` construct a RealTupleType with two components
`` `RealTupleType(RealType a, RealType b, CoordinateSystem coord_sys, Set set)` construct a RealTupleType with two components
`` `RealTupleType(RealType a, RealType b, RealType c)` construct a RealTupleType with three components
`` `RealTupleType(RealType a, RealType b, RealType c, CoordinateSystem coord_sys, Set set)` construct a RealTupleType with three components
`` `RealTupleType(RealType a, RealType b, RealType c, RealType d)` construct a RealTupleType with four components
`` `RealTupleType(RealType a, RealType b, RealType c, RealType d, CoordinateSystem coord_sys, Set set)` construct a RealTupleType with four components

Method Summary
`MathType` `binary(MathType type, int op, Vector names)` Performs an arithmetic operation with another MathType.
`ShadowType` `buildShadowType(DataDisplayLink link, ShadowType parent)`
`boolean` `equalsExceptName(MathType type)` this is useful for determining compatibility of Data objects for binary mathematical operations; any RealTypes are equal; any TextTypes are equal; TupleTypes are equal if their components are equal; FunctionTypes are equal if their domains and ranges are equal
`boolean` `equalsExceptNameButUnits(MathType type)`
`CoordinateSystem` `getCoordinateSystem()` get default CoordinateSystem
`Set` `getDefaultSet()` get default Set
`Unit[]` `getDefaultUnits()` get default Units of RealType components; copy DefaultUnits array to ensure that it cannot be altered
`static RealType[]` `makeArray(RealType a)`
`static RealType[]` `makeArray(RealType a, RealType b)`
`static RealType[]` `makeArray(RealType a, RealType b, RealType c)`
`static RealType[]` `makeArray(RealType a, RealType b, RealType c, RealType d)`
`Data` `missingData()` returns a missing Data object for any MathType
`String` `prettyString(int indent)`
`void` `setDefaultSet(Set sampling)` set the default sampling; this is an unavoidable violation of MathType immutability - a RealTupleType must be an argument (directly or through a SetType) to the constructor of its default Set; this method throws an Exception if getDefaultSet has previously been invoked
`MathType` `unary(int op, Vector names)`

Methods inherited from class visad.TupleType
`__getitem__, __len__, cloneDerivative, equals, getComponent, getComponents, getDimension, getFlat, getIndex, getIndex, getNumberOfRealComponents, getRealComponents, hashCode`

Methods inherited from class visad.MathType
`addTimeAlias, findScalarType, guessMaps, main, prettyString, stringToType, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### SpatialCartesian2DTuple

    public static final RealTupleType SpatialCartesian2DTuple

  System intrinsic RealTupleType for (RealType.XAxis, RealType.YAxis)

### SpatialCartesian3DTuple

    public static final RealTupleType SpatialCartesian3DTuple

  System intrinsic for (RealType.XAxis, RealType.YAxis, RealType.ZAxis)

### SpatialEarth2DTuple

    public static final RealTupleType SpatialEarth2DTuple

  System intrinsic for (RealType.Longitude, RealType.Latitude)

### LatitudeLongitudeTuple

    public static final RealTupleType LatitudeLongitudeTuple

  System intrinsic for (RealType.Latitude, RealType.Longitude)

### SpatialEarth3DTuple

    public static final RealTupleType SpatialEarth3DTuple

  System intrinsic for (RealType.Longitude, RealType.Latitude, RealType.Altitude)

### LatitudeLongitudeAltitude

    public static final RealTupleType LatitudeLongitudeAltitude

  System intrinsic for (RealType.Latitude, RealType.Longitude, RealType.Altitude)

### Time1DTuple

    public static final RealTupleType Time1DTuple

  System intrinsic for (RealType.Time)

### Generic2D

    public static final RealTupleType Generic2D

  System intrinsic for (RealType.Generic, RealType.Generic)

### Generic3D

    public static final RealTupleType Generic3D

  System intrinsic for (RealType.Generic, RealType.Generic, RealType.Generic)

Constructor Detail

### RealTupleType

    public RealTupleType(RealType[] types)
                  throws VisADException

  array of component types; default CoordinateSystem and Set are null

### RealTupleType

    public RealTupleType(RealType a)
                  throws VisADException

  construct a RealTupleType with one component

### RealTupleType

    public RealTupleType(RealType a,
                         RealType b)
                  throws VisADException

  construct a RealTupleType with two components

### RealTupleType

    public RealTupleType(RealType a,
                         RealType b,
                         RealType c)
                  throws VisADException

  construct a RealTupleType with three components

### RealTupleType

    public RealTupleType(RealType a,
                         RealType b,
                         RealType c,
                         RealType d)
                  throws VisADException

  construct a RealTupleType with four components

### RealTupleType

    public RealTupleType(RealType[] types,
                         CoordinateSystem coord_sys,
                         Set set)
                  throws VisADException

  array of component types; default CoordinateSystem for values of this type (including Function domains) and may be null; default Set used when this type is a FunctionType domain and may be null

### RealTupleType

    public RealTupleType(RealType a,
                         CoordinateSystem coord_sys,
                         Set set)
                  throws VisADException

  construct a RealTupleType with one component

### RealTupleType

    public RealTupleType(RealType a,
                         RealType b,
                         CoordinateSystem coord_sys,
                         Set set)
                  throws VisADException

  construct a RealTupleType with two components

### RealTupleType

    public RealTupleType(RealType a,
                         RealType b,
                         RealType c,
                         CoordinateSystem coord_sys,
                         Set set)
                  throws VisADException

  construct a RealTupleType with three components

### RealTupleType

    public RealTupleType(RealType a,
                         RealType b,
                         RealType c,
                         RealType d,
                         CoordinateSystem coord_sys,
                         Set set)
                  throws VisADException

  construct a RealTupleType with four components

### RealTupleType

    RealTupleType(RealType[] types,
                  boolean b)

  trusted constructor for initializers

### RealTupleType

    RealTupleType(RealType[] types,
                  CoordinateSystem coord_sys,
                  boolean b)

  trusted constructor for initializers

Method Detail

### binary

    public MathType binary(MathType type,
                           int op,
                           Vector names)
                    throws TypeException,
                           VisADException

  Performs an arithmetic operation with another MathType. CoordinateSystem information, if it exists, will be lost.

  Overrides:
    `binary` in class `TupleType`
  Parameters:
    `type` - The other MathType.
    `op` - The arithmetic operation (see `Data`).
    `names` - Database of names.
  Returns:
    The MathType corresponding to the specified arithmetic operation between this and the other MathType. If the returned type is a RealTupleType, then it will not have a CoordinateSystem.
  Throws:
    `TypeException` - `type` is null or can't be arithmetically combined with a RealTupleType.
    `VisADException` - Couldn't create necessary VisAD object.
  See Also:
    `Data`

### unary

    public MathType unary(int op,
                          Vector names)
                   throws VisADException

  Overrides:
    `unary` in class `TupleType`
  Throws:
    `VisADException`

### makeArray

    public static RealType[] makeArray(RealType a)

### makeArray

    public static RealType[] makeArray(RealType a,
                                       RealType b)

### makeArray

    public static RealType[] makeArray(RealType a,
                                       RealType b,
                                       RealType c)

### makeArray

    public static RealType[] makeArray(RealType a,
                                       RealType b,
                                       RealType c,
                                       RealType d)

### getDefaultUnits

    public Unit[] getDefaultUnits()

  get default Units of RealType components; copy DefaultUnits array to ensure that it cannot be altered

### getCoordinateSystem

    public CoordinateSystem getCoordinateSystem()

  get default CoordinateSystem

### setDefaultSet

    public void setDefaultSet(Set sampling)
                       throws VisADException

  set the default sampling; this is an unavoidable violation of MathType immutability - a RealTupleType must be an argument (directly or through a SetType) to the constructor of its default Set; this method throws an Exception if getDefaultSet has previously been invoked

  Throws:
    `VisADException`

### getDefaultSet

    public Set getDefaultSet()

  get default Set

### equalsExceptName

    public boolean equalsExceptName(MathType type)

  Description copied from class: `MathType`
  this is useful for determining compatibility of Data objects for binary mathematical operations; any RealTypes are equal; any TextTypes are equal; TupleTypes are equal if their components are equal; FunctionTypes are equal if their domains and ranges are equal

  Overrides:
    `equalsExceptName` in class `TupleType`

### equalsExceptNameButUnits

    public boolean equalsExceptNameButUnits(MathType type)

  Overrides:
    `equalsExceptNameButUnits` in class `TupleType`

### prettyString

    public String prettyString(int indent)

  Overrides:
    `prettyString` in class `TupleType`

### missingData

    public Data missingData()

  Description copied from class: `MathType`
  returns a missing Data object for any MathType

  Overrides:
    `missingData` in class `TupleType`

### buildShadowType

    public ShadowType buildShadowType(DataDisplayLink link,
                                      ShadowType parent)
                               throws VisADException,
                                      RemoteException

  Overrides:
    `buildShadowType` in class `TupleType`
  Throws:
    `VisADException`
    `RemoteException`